local CreateFrame, UIParent, _G, UnitName, GetRealmName, type, pairs, ipairs, insert, print, sort, wipe, remove = CreateFrame, UIParent, _G, UnitName, GetRealmName, type, pairs, ipairs, table.insert, print, table.sort, table.wipe, table.remove;
local _Questic = CreateFrame("FRAME","_Questic_ADDON_Globals")


BINDING_HEADER_QUESTIC = "Questic"
for i = 1, 6 do
    _G["BINDING_NAME_CLICK QUESTIC_ADDON_ITEMBAR_ITEM" .. i .. ":LeftButton"] = "Use quest item " .. i
end

local SavedDataLoaded = false;
local LockSV = false;

local GlobalsDefault = {
    GossipAutoSelectList = {},
    GossipAutoSelectDisabledPresets = {},
    GossipAutoSelectBlackList = {},
    QuestItemBlackList = {},
    --QRRouteList = {},
    --WQFilterList = {},
}

local DefaultCharaTable = {
    SelectedProfile = "Default",
}

local Centerx, Centery = UIParent:GetCenter();
local DefaultProfileTable = {
    MinimapIconPositionx = -12,
    MinimapIconPositiony = -80,
    OptionsMenuPositionx = Centerx,
    OptionsMenuPositiony = 1.5 * Centery,
    EnableMinimapIcon = true,
    Enable = true,
    AutoShare = false,
    AutoAccept = true,
    AutoAcceptNormal = true,
    AutoAcceptLowLevel = false,
    AutoAcceptDaily = false,
    AutoAcceptWeekly = false,
    AutoAcceptQuestsInBag = true,
    AutoTurnin = true,
    AutoTurninQuestItems = true,
    AutoTurninNonQuestItems = false,
    AutoturninCurrency = false,
    AutoturninMoney = false,
    QuestItemBar = true,
    QuestItemBarGrowthDirection = "Right",
    QuestItemBarScale = 1,
    QuestItemBarShowCD = true,
    QuestItemBarShowCount = true,
    QuestItemBarShowKeyBinding = true,
    QuestItemBarMaxItemsDisplayed = 0,
    QuestItemBarPositionx = Centerx,
    QuestItemBarPositiony = 1.5 * Centery,
    QuestItemBarEnableBlackList = true,
    QREnable = true,
    QRScale = 1,
    QRHideMax = true,
    QRDisplayType = "Current and next objective",
    QRPositionx = Centerx,
    QRPositiony = 1.5 * Centery,
    QRLoadedRoute = { Type = nil, Index = nil },
    GossipAutoSelect = true,
    GossipAutoSelectIgnoreSkip = false,
    GossipAutoSelectPriorSkip = true,
    GossipAutoSelectSingleOptionGossip = false,
    RightClickGossipAdd = true,
    RightClickGossipBlacklistAdd = true,
    CinematicSkip = false,
    SuppressKeys = true,
    AltSuppress = true,
    ShiftSuppress = true,
    CTRLSuppress = true,
    GossipQuickSelect = true,
    HideBlizzGossipFrame = true,
    IncludeQuestsInGosseipSelect = true,
    QuickQuestEnable = true,
    HideBlizzQuestFrame = true,
    GossipQuickSelectScale = 1.5,

    --[[
    WQQuestlog = true,
    WQQuestlogInRaid = true,
    WQQuestlogInDungeon = true,
    WQQuestlogInCombat = false,
    WQQuestlogInEncounter = false,
    WQQuestlogFilter = "None",
    WQQuestlogDisplayFormat = "Default", 
    WQQuestlogDisplayFormatC1 = "/t - /n", 
    WQQuestlogDisplayFormatC2 = "/z (/f)", 
    WQQuestlogSortBy = "Time",
    WQQuestlogHeight = 350,
    WQQuestlogWidth = 250,
    WQQuestlogScale = 1,
    WQQuestlogx = Centerx,
    WQQuestlogy = 1.5*Centery,


    WQAlertOnSpawn = true,
    WQAlertOfExpire = 30,
    WQAlertFilters = {},
    WQAlertInChat = false,
    WQAlertDisplay = true,
    WQAlertDisplayScale = 1,
    WQAlertDisplayx = Centerx,
    WQAlertDisplayy = 1.5 * Centery,
]]
}

local function GetSelectedProfile(OverrideSelectedProfile, VarName)
    local CharacterProfile = UnitName("player") .. "_" .. GetRealmName();
    local TableIndex = "Profiles";
    local ProfileIndex = "Default";

    if _G[_Questic.AddonName .. "_DB"] and _G[_Questic.AddonName .. "_DB"].Characters[CharacterProfile] and _G[_Questic.AddonName .. "_DB"].Characters[CharacterProfile]["SelectedProfile"] then
        ProfileIndex = _G[_Questic.AddonName .. "_DB"].Characters[CharacterProfile]["SelectedProfile"];
    end

    ProfileIndex = OverrideSelectedProfile or ProfileIndex or "Default"

    if VarName then
        if GlobalsDefault[VarName] then
            ProfileIndex = "Globals"
            TableIndex = nil;
        end
    end

    return ProfileIndex, TableIndex;
end

local RefreshCycle = false;
local function RefreshAddonFrames(VarName)
    if RefreshCycle then return false; end

    RefreshCycle = true;

    VarName = VarName or "ALL";

    --Hide Blizz frames
    if VarName == "ALL" or VarName == "Enable" or VarName == "GossipQuickSelect" or VarName == "HideBlizzGossipFrame" or
            VarName == "SuppressKeys" or VarName == "CTRLSuppress" or VarName == "ShiftSuppress" or VarName == "AltSuppress" then
        _Questic.GossipFunctions.GossipFrameSuppress();
    end
    if VarName == "ALL" or VarName == "Enable" or VarName == "GossipQuickSelect" or VarName == "IncludeQuestsInGosseipSelect" or VarName == "HideBlizzQuestFrame" or
            VarName == "SuppressKeys" or VarName == "CTRLSuppress" or VarName == "ShiftSuppress" or VarName == "AltSuppress" then
        _Questic.QuestFrameSuppress();
    end

    --Gossip quick select frame
    if VarName == "ALL" or VarName == "Enable" or VarName == "GossipQuickSelect" or VarName == "GossipQuickSelectScale" or VarName == "IncludeQuestsInGosseipSelect" or
            VarName == "SuppressKeys" or VarName == "CTRLSuppress" or VarName == "ShiftSuppress" or VarName == "AltSuppress" or VarName == "QuickQuestEnable" then
        _Questic.GossipQuickSelect:Update();
    end

    --Gossip auto select
    if VarName == "ALL" or VarName == "GossipAutoSelectList" then
        _Questic.GossipFunctions.ChangeGossip("UserDefined");
    end
    if VarName == "ALL" or VarName == "GossipAutoSelectDisabledPresets" then
        _Questic.GossipFunctions.ChangeGossip("Preset");
    end

    --Minimap Icon
    if VarName == "ALL" or VarName == "MinimapIconPositiony" or VarName == "MinimapIconPositionx" or VarName == "EnableMinimapIcon" or VarName == "Enable" then
        _Questic.MinimapIcon:Refresh();
    end

    --Options Menu Position
    if VarName == "ALL" or VarName == "OptionsMenuPositionx" or VarName == "OptionsMenuPositiony" then
        _Questic.OptionsMenu.UpdatePosition();
    end

    --QuestItemBar
    if VarName == "ALL" or VarName == "QuestItemBarPositionx" or VarName == "QuestItemBarPositiony" or VarName == "QuestItemBarScale" or VarName == "Enable" or VarName == "QuestItemBar" or
            VarName == "QuestItemBarShowCD" or VarName == "QuestItemBarShowCount" or VarName == "QuestItemBarShowKeyBinding" or VarName == "QuestItemBarMaxItemsDisplayed" or
            VarName == "QuestItemBarEnableBlackList" or VarName == "QuestItemBlackList" or VarName == "QuestItemBarGrowthDirection" then
        _Questic.QuestItemBar.Update();
    end

    --WQ Alerts
    --[[
    if VarName == "ALL" or VarName == "WQAlerts" or VarName == "WQAlertOnSpawn" or VarName == "WQAlertOfExpire" or VarName == "WQAlertFilters" or VarName == "WQAlertInChat" or
            VarName == "WQAlertDisplay"  or VarName == "WQAlertDisplayScale" or VarName == "WQAlertDisplayx" or VarName == "WQAlertDisplayy" then
        _Questic.WQFunctions:Update()
    end]]

    if VarName == "ALL" or VarName == "QRRouteList" then
        --Questic_ADDON_RoutePlanner:UpdateOverlay(nil,nil,true);
    end

    --RouteDisplay
    if VarName == "ALL" or VarName == "QRPositionx" or VarName == "QRPositiony" or VarName == "QRScale" then
        --_Questic.RoutePlannerFuncs.UpdateParameters()
    end

    if VarName == "ALL" or VarName == "Enable" or VarName == "QREnable" or VarName == "QRLoadedRoute" then
        --Questic_ADDON_RouteDisplay:Refresh();
    end

    --options elements
    if _Questic.OptionsMenuFuncs then
        _Questic.OptionsMenuFuncs.Refresh();
    end

    RefreshCycle = false;
end

_Questic.RefreshAddonFrames = RefreshAddonFrames;

local function LoadSV()
    LockSV = true;
    local CharaIndex = UnitName("player") .. "_" .. GetRealmName()

    --create options table
    if _G[_Questic.AddonName .. "_DB"] then

    else
        _G[_Questic.AddonName .. "_DB"] = {};
    end

    --character table
    if _G[_Questic.AddonName .. "_DB"].Characters then
        if type(_G[_Questic.AddonName .. "_DB"].Characters[CharaIndex]) == "nil" then
            _G[_Questic.AddonName .. "_DB"].Characters[CharaIndex] = {};
        end
    else
        _G[_Questic.AddonName .. "_DB"].Characters = {};
        _G[_Questic.AddonName .. "_DB"].Characters[CharaIndex] = {};
    end

    _G[_Questic.AddonName .. "_DB"].Characters[CharaIndex]["SelectedProfile"] = _G[_Questic.AddonName .. "_DB"].Characters[CharaIndex]["SelectedProfile"] or "Default"

    local SelectedProfile = _G[_Questic.AddonName .. "_DB"].Characters[CharaIndex]["SelectedProfile"];

    --profiles table
    if _G[_Questic.AddonName .. "_DB"].Profiles then
        if type(_G[_Questic.AddonName .. "_DB"].Profiles[SelectedProfile]) == "nil" then
            _G[_Questic.AddonName .. "_DB"].Profiles[SelectedProfile] = {};
        end
    else
        _G[_Questic.AddonName .. "_DB"].Profiles = {};
        _G[_Questic.AddonName .. "_DB"].Profiles[SelectedProfile] = {};
    end

    _G[_Questic.AddonName .. "_DB"].Profiles.Default = _G[_Questic.AddonName .. "_DB"].Profiles.Default or {};

    --Global table
    _G[_Questic.AddonName .. "_DB"]["Globals"] = _G[_Questic.AddonName .. "_DB"]["Globals"] or {};
    if type(_G[_Questic.AddonName .. "_DB"]["Globals"]) == "nil" then
        _G[_Questic.AddonName .. "_DB"]["Globals"] = GlobalsDefault
    else
        for i, v in pairs(GlobalsDefault) do
            if type(_G[_Questic.AddonName .. "_DB"]["Globals"][i]) == "nil" then
                _G[_Questic.AddonName .. "_DB"]["Globals"][i] = v
            end
        end
    end



    if not SavedDataLoaded then --first load reorganize data
        for i, v in pairs(_G[_Questic.AddonName .. "_DB"]) do
            if i ~= "Globals" and i ~= "Characters" and i ~= "Profiles" then
                if v.GossipAutoSelectList then
                    for _, GossipData in ipairs(v.GossipAutoSelectList) do
                        if type(GossipData.Gossip) == "string" and type(GossipData.NPC) == "string" then
                            local InTable = false;
                            for _, ExistingGossipData in ipairs(_G[_Questic.AddonName .. "_DB"]["Globals"]["GossipAutoSelectList"]) do
                                if GossipData.Gossip == ExistingGossipData.Gossip and GossipData.NPC == ExistingGossipData.NPC then
                                    InTable = true;
                                    break;
                                end
                            end
                            if not InTable then
                                insert(_G[_Questic.AddonName .. "_DB"]["Globals"]["GossipAutoSelectList"], {
                                    Gossip = GossipData.Gossip,
                                    NPC = GossipData.NPC,
                                    Note = GossipData.Note,
                                    Disable = GossipData.Disable
                                });
                            end
                        end
                    end
                    v.GossipAutoSelectList = nil;
                end
                if v.GossipAutoSelectDisabledPresets then
                    for IndexName, Condition in pairs(v.GossipAutoSelectDisabledPresets) do
                        _G[_Questic.AddonName .. "_DB"]["Globals"]["GossipAutoSelectDisabledPresets"][IndexName] = Condition;
                    end
                    v.GossipAutoSelectDisabledPresets = nil;
                end

                _G[_Questic.AddonName .. "_DB"].Characters[i] = _G[_Questic.AddonName .. "_DB"].Characters[i] or {};
                _G[_Questic.AddonName .. "_DB"].Profiles[i] = _G[_Questic.AddonName .. "_DB"].Profiles[i] or {};
                for VarName, VarValue in pairs(v) do
                    if VarName ~= "SelectedProfile" then
                        _G[_Questic.AddonName .. "_DB"].Profiles[i][VarName] = VarValue;
                    end
                    _G[_Questic.AddonName .. "_DB"].Characters[i]["SelectedProfile"] = i;
                end
                _G[_Questic.AddonName .. "_DB"][i] = nil;
            end
        end
        for i, v in pairs(_G[_Questic.AddonName .. "_DB"].Profiles) do
            if v.GroupTrackPosition and v.GroupTrackPosition.x and v.GroupTrackPosition.y then
                v.GroupTrackPositionx = v.GroupTrackPosition.x;
                v.GroupTrackPositiony = v.GroupTrackPosition.y;
                v.GroupTrackPosition = nil;
            end
            if v.QuestItemBarPosition and v.QuestItemBarPosition.x and v.QuestItemBarPosition.y then
                v.QuestItemBarPositionx = v.QuestItemBarPosition.x;
                v.QuestItemBarPositiony = v.QuestItemBarPosition.y;
                v.QuestItemBarPosition = nil;
            end
            if v.RewardMenuPosition and v.RewardMenuPosition.x and v.RewardMenuPosition.y then
                v.RewardMenuPositionx = v.RewardMenuPosition.x;
                v.RewardMenuPositiony = v.RewardMenuPosition.y;
                v.RewardMenuPosition = nil;
            end
            if v.OptionsMenuPosition and v.OptionsMenuPosition.x and v.OptionsMenuPosition.y then
                v.OptionsMenuPositionx = v.OptionsMenuPosition.x;
                v.OptionsMenuPositiony = v.OptionsMenuPosition.y;
                v.OptionsMenuPosition = nil;
            end
            if v.MinimapIconPosition and v.MinimapIconPosition.x and v.MinimapIconPosition.y then
                v.MinimapIconPositionx = v.MinimapIconPosition.x;
                v.MinimapIconPositiony = v.MinimapIconPosition.y;
                v.MinimapIconPosition = nil;
            end
        end
    end



    --check old character tables
    for i, v in pairs(DefaultCharaTable) do
        for CIndex, CharaData in pairs(_G[_Questic.AddonName .. "_DB"].Characters) do
            if type(CharaData[i]) == "nil" then
                CharaData[i] = v;
            end
        end
    end

    for i, v in pairs(DefaultProfileTable) do
        for PIndex, ProfileData in pairs(_G[_Questic.AddonName .. "_DB"].Profiles) do
            if type(ProfileData[i]) == "nil" then
                ProfileData[i] = v;
            end
        end
    end

    --load callbacks
    RefreshAddonFrames();

    SavedDataLoaded = true;
    LockSV = false;
end

local AddonLoadFrame = CreateFrame("FRAME")

AddonLoadFrame:SetScript("OnEvent", function(self, Event, ...)
    if Event == "ADDON_LOADED" and ... == _Questic.AddonName then
        LoadSV()
    end
end)

AddonLoadFrame:RegisterEvent("ADDON_LOADED")

_Questic.ProfileManagement = function(Action, Profile, NewName)
    if Profile == "Default" and (Action == "Rename" or Action == "Delete") then
        print("Questic: \"Default\" profile cannot be deleted or renamed.")
        return Profile;
    end

    if Action == "GetAll" then
        local ProfileNameTable = {}
        for i, v in pairs(_G[_Questic.AddonName .. "_DB"].Profiles) do
            if i ~= "Default" then
                insert(ProfileNameTable, i);
            end
        end
        sort(ProfileNameTable, function(a, b) return a < b end);
        insert(ProfileNameTable, 1, "Default");
        return ProfileNameTable;
    elseif Action == "GetActive" then
        local SelectedProfile = GetSelectedProfile(nil, "Enable");
        return SelectedProfile
    elseif Action == "CreateNew" then
        for i = 1, 100 do
            if not _G[_Questic.AddonName .. "_DB"].Profiles["New Profile " .. i] then
                _G[_Questic.AddonName .. "_DB"].Profiles["New Profile " .. i] = {}
                if _G[_Questic.AddonName .. "_DB"].Profiles["Default"] then
                    for VarName, DefaultValue in pairs(_G[_Questic.AddonName .. "_DB"].Profiles["Default"]) do
                        _G[_Questic.AddonName .. "_DB"].Profiles["New Profile " .. i][VarName] = DefaultValue;
                    end
                else
                    for VarName, DefaultValue in pairs(DefaultProfileTable) do
                        _G[_Questic.AddonName .. "_DB"].Profiles["New Profile " .. i][VarName] = DefaultValue;
                    end
                end
                return "New Profile " .. i
            end
        end
        print("Questic: More then 100 New Profiles rename one to create a new profile.")
    elseif Action == "Rename" and type(Profile) == "string" and type(NewName) == "string" and Profile ~= NewName then
        if _G[_Questic.AddonName .. "_DB"].Profiles[Profile] then
            if _G[_Questic.AddonName .. "_DB"].Profiles[NewName] then
                print("Questic: Profile with the named \"" .. NewName .. "\" already exists.")
                return Profile
            else
                _G[_Questic.AddonName .. "_DB"].Profiles[NewName] = _G[_Questic.AddonName .. "_DB"].Profiles[Profile];
                _G[_Questic.AddonName .. "_DB"].Profiles[Profile] = nil;
                for i, v in pairs(_G[_Questic.AddonName .. "_DB"].Characters) do
                    if v.SelectedProfile == Profile then
                        v.SelectedProfile = NewName;
                    end
                end
                return NewName
            end
        end
    elseif Action == "Delete" and type(Profile) == "string" then
        _G[_Questic.AddonName .. "_DB"].Profiles[Profile] = nil;
        for i, v in pairs(_G[_Questic.AddonName .. "_DB"].Characters) do
            if v.SelectedProfile == Profile then
                if i == UnitName("player") .. "_" .. GetRealmName() then
                    LockSV = true;
                    v.SelectedProfile = "Default";
                    LoadSV();
                else
                    v.SelectedProfile = "Default";
                end
            end
        end
    elseif Action == "Load" and type(Profile) == "string" and _G[_Questic.AddonName .. "_DB"].Profiles[Profile] then
        LockSV = true;
        local SelectedProfile = GetSelectedProfile(nil, "Enable");
        _G[_Questic.AddonName .. "_DB"].Characters[UnitName("player") .. "_" .. GetRealmName()].SelectedProfile = Profile;
        LoadSV();
        return Profile
    elseif Action == "Copy" and type(Profile) == "string" and _G[_Questic.AddonName .. "_DB"].Profiles[Profile] and type(NewName) == "string" and _G[_Questic.AddonName .. "_DB"].Profiles[NewName] then
        for i, v in pairs(_G[_Questic.AddonName .. "_DB"].Profiles[NewName]) do
            _G[_Questic.AddonName .. "_DB"].Profiles[Profile][i] = v;
        end
        if _G[_Questic.AddonName .. "_DB"].Characters[UnitName("player") .. "_" .. GetRealmName()].SelectedProfile == Profile then
            LockSV = true;
            LoadSV();
        end
    end
end


_Questic.SaveVariable = function(VarName, Var, SelectedProfile)
    if LockSV then return nil end;
    local SelectedTableIndex = "Characters";
    SelectedProfile, SelectedTableIndex = GetSelectedProfile(SelectedProfile, VarName)

    local PrevVal = nil

    if SelectedTableIndex then
        if _G[_Questic.AddonName .. "_DB"] and _G[_Questic.AddonName .. "_DB"][SelectedTableIndex] and _G[_Questic.AddonName .. "_DB"][SelectedTableIndex][SelectedProfile] then
            PrevVal = _G[_Questic.AddonName .. "_DB"][SelectedTableIndex][SelectedProfile][VarName]
            _G[_Questic.AddonName .. "_DB"][SelectedTableIndex][SelectedProfile][VarName] = Var
        end
    else
        if _G[_Questic.AddonName .. "_DB"] and _G[_Questic.AddonName .. "_DB"][SelectedProfile] then
            PrevVal = _G[_Questic.AddonName .. "_DB"][SelectedProfile][VarName]
            _G[_Questic.AddonName .. "_DB"][SelectedProfile][VarName] = Var
        end
    end

    if (type(PrevVal) == "number" and _Questic.Round(PrevVal, 2) ~= _Questic.Round(Var, 2)) or (type(PrevVal) ~= "number" and PrevVal ~= Var) then
        RefreshAddonFrames(VarName);
    end

    return true
end

_Questic.GetVariable = function(VarName, SelectedProfile)
    local SelectedTableIndex = "Characters";
    SelectedProfile, SelectedTableIndex = GetSelectedProfile(SelectedProfile, VarName)

    if SelectedTableIndex then
        if _G[_Questic.AddonName .. "_DB"] and _G[_Questic.AddonName .. "_DB"][SelectedTableIndex] and _G[_Questic.AddonName .. "_DB"][SelectedTableIndex][SelectedProfile] and type(_G[_Questic.AddonName .. "_DB"][SelectedTableIndex][SelectedProfile][VarName]) ~= "nil" then
            return _G[_Questic.AddonName .. "_DB"][SelectedTableIndex][SelectedProfile][VarName]
        else
            return nil
        end
    else
        if _G[_Questic.AddonName .. "_DB"] and _G[_Questic.AddonName .. "_DB"][SelectedProfile] and type(_G[_Questic.AddonName .. "_DB"][SelectedProfile][VarName]) ~= "nil" then
            return _G[_Questic.AddonName .. "_DB"][SelectedProfile][VarName]
        else
            return nil
        end
    end
end

_Questic.IsEnabled = function()
    if _Questic.GetVariable("Enable") then
        if _Questic.GetVariable("SuppressKeys") and ((_Questic.GetVariable("AltSuppress") and IsAltKeyDown())
                or (_Questic.GetVariable("ShiftSuppress") and IsShiftKeyDown())
                or (_Questic.GetVariable("CTRLSuppress") and IsControlKeyDown())) then
            return false;
        end
        return true;
    end
    return false;
end
