local Widgets = _QuesticWidgets
local MouseIsOver, insert = MouseIsOver, table.insert;

Widgets.CreateButton = function(self, Parent)
    local Button = Widgets:CreateFrame(Parent)
    Button:Backdrop()

    Button.State = "Normal"
    Button.Focus = false

    Button.SetFocus = function(self, Focus)
        Button.Focus = Focus
        self:PresetBorders(self.State, self.Focus)
    end

    Button.EnterLeave = function(self, Enter)
        if Enter then
            if self.State ~= "Pushed" and not self.Disable and (not self.ActiveCheck or (self.ActiveCheck and self.ActiveCheck())) then
                self.State = "MouseOver"
                self:PresetBorders(self.State, self.Focus)
            end
        else
            self.State = "Normal"
            self:PresetBorders(self.State, self.Focus)
        end
    end

    Button.MouseInteraction = function(self, Up, Button)
        if Up then
            if not self.Disable and (not self.ActiveCheck or (self.ActiveCheck and self.ActiveCheck())) and MouseIsOver(self) then
                self.State = "MouseOver"
                self:PresetBorders(self.State, self.Focus)
                if self.OnClick then
                    self:OnClick(Button)
                end
            else
                self:Backdrop("Border")
                self.State = "Normal"
                self:PresetBorders(self.State, self.Focus)
            end
        else
            if not self.Disable and (not self.ActiveCheck or (self.ActiveCheck and self.ActiveCheck())) then
                self.State = "Pushed"
                self:PresetBorders(self.State, self.Focus)
            end
        end
    end
    Button:MakeInteractable(true);

    Button.CloseButtonTexture = function(self)
        self:SetIcon(Widgets.MediaPath.."PlusMask.blp", 0, 1, 0, 1, 1, 0.25, 0.25, true, 45);
    end

    insert(Button.LM, "SetFocus")
    insert(Button.LM, "ActiveCheck")
    insert(Button.LM, "CloseButtonTexture")
    insert(Button.LM, "OnClick")
    insert(Button.LM, "State")
    insert(Button.LM, "Focus")

    return Button
end
