local Widgets = _QuesticWidgets
local insert, ipairs = table.insert, ipairs;

local FontStrings = {}

local function Release(self)
    self:SetTextColor(1,0.82,0)
    self:SetParent(Widgets)
    local Font, _, Flags = self:GetFont()
    self:SetFont(Font, 11, Flags)
    self:SetHeight(0)
    self:SetWidth(0)
    self:SetJustifyH("CENTER")
    self:SetJustifyV("CENTER")
    self:Hide()
end

local function SetFontSizeOnly(self,Size)
    local Font, _, Flags = self:GetFont()
    self:SetFont(Font, Size, Flags)
end 

Widgets.FetchFontString = function(self, Parent)
    local String
    for i, v in ipairs(FontStrings) do
        if not v:IsShown() then
            String = v
        end
    end

    if not String then
        String = Widgets:CreateFontString(nil, "OVERLAY", "GameFontNormal")
        insert(FontStrings,String)
        String.Release = Release
        String.SetFontSizeOnly = SetFontSizeOnly
    end

    String:ClearAllPoints()
    String:SetParent(Parent or Widgets)
    String:SetText("")
    String:Show()

    return String
end