local Widgets = _QuesticWidgets
local UIParent, insert = UIParent, table.insert;
local BorderSize, Padding = Widgets.BorderSize, Widgets.Padding;

Widgets.VerifyAction = function(self, Parent, Title, Text, AcceptFunc, CancelFunc)
    local VerifyWindow = Widgets:CreateFrame(Parent)
    VerifyWindow:SetFrameStrata("Tooltip")
    VerifyWindow:Backdrop()
    VerifyWindow:Size(250, 100)
    VerifyWindow:SetPoint("CENTER", UIParent)

    VerifyWindow.Header = Widgets:CreateFrame(VerifyWindow)
    VerifyWindow.Header:SetPoint("TOPLEFT", BorderSize + Padding, -BorderSize - Padding)
    VerifyWindow.Header:SetPoint("TOPRIGHT", -BorderSize - Padding, -BorderSize - Padding)
    VerifyWindow.Header:Size(nil, 20)
    VerifyWindow.Header:Backdrop()
    VerifyWindow.Header:SetText(Title)

    VerifyWindow.Accept = Widgets:CreateButton(VerifyWindow)
    VerifyWindow.Accept:SetPoint("BOTTOMLEFT", BorderSize + Padding, BorderSize + Padding)
    VerifyWindow.Accept:SetPoint("BOTTOMRIGHT", VerifyWindow, "BOTTOM", -Padding / 2, BorderSize + Padding)
    VerifyWindow.Accept:Size(nil, 20)
    VerifyWindow.Accept:SetIcon(Widgets.MediaPath.."CheckMask.blp", 0, 1, 0, 1, 0.25, 1, 0.25, true, 135, true);
    VerifyWindow.Accept.OnClick = function()
        VerifyWindow:Release()
        if AcceptFunc then
            AcceptFunc()
        end
    end

    VerifyWindow.Cancel = Widgets:CreateButton(VerifyWindow)
    VerifyWindow.Cancel:SetPoint("BOTTOMRIGHT", -BorderSize - Padding, BorderSize + Padding)
    VerifyWindow.Cancel:SetPoint("BOTTOMLEFT", VerifyWindow, "BOTTOM", Padding / 2, BorderSize + Padding)
    VerifyWindow.Cancel:Size(nil, 20)
    VerifyWindow.Cancel:SetIcon(Widgets.MediaPath.."PlusMask.blp", 0, 1, 0, 1, 1, 0.25, 0.25, true, 45, true);
    VerifyWindow.Cancel.OnClick = function()
        VerifyWindow:Release()
        if CancelFunc then
            CancelFunc()
        end
    end

    VerifyWindow.Content = Widgets:CreateFrame(VerifyWindow)
    VerifyWindow.Content:SetPoint("TOPLEFT", VerifyWindow.Header, "BOTTOMLEFT", 0, -Padding)
    VerifyWindow.Content:SetPoint("BOTTOMRIGHT", VerifyWindow.Cancel, "TOPRIGHT", 0, Padding)
    VerifyWindow.Content:Backdrop()
    VerifyWindow.Content:SetText(Text, 11, 1, 1, 1, "LEFT", "TOP")

    insert(VerifyWindow.LM, "Header");
    insert(VerifyWindow.LM, "Accept");
    insert(VerifyWindow.LM, "Cancel");
    insert(VerifyWindow.LM, "Content");

    return VerifyWindow
end