local Widgets = _QuesticWidgets
local BorderSize, Padding = Widgets.BorderSize, Widgets.Padding;
local insert = table.insert;

Widgets.CreateWindow = function(self, Parent, Name)
    local Window = Widgets:CreateFrame(Parent)
    Window:Backdrop()
    Window:SetPoint("CENTER")

    Window.CloseButton = Widgets:CreateButton(Window)
    Window.CloseButton:Size(25, 25)
    Window.CloseButton:CloseButtonTexture();
    Window.CloseButton:SetPoint("TOPRIGHT", -(BorderSize + Padding), -(BorderSize + Padding))
    Window.CloseButton.OnClick = function(self)
        Window:Release()
        if Window.OnCloseFunc then 
            Window.OnCloseFunc()
        end 
    end

    Window.Header = Widgets:CreateFrame(Window)
    Window.Header:Size(nil, 25)
    Window.Header:SetPoint("TOPLEFT", BorderSize + Padding, -(BorderSize + Padding))
    Window.Header:SetPoint("TOPRIGHT", Window.CloseButton, "TOPLEFT", -Padding, 0)
    Window.Header:SetText(Name or "", 14)
    Window.Header:Backdrop()

    insert(Window.LM, "CloseButton");
    insert(Window.LM, "Header");

    return Window
end
